# -*- coding: utf-8 -*-
"""
Created on Mon Nov 20 13:49:55 2017

@author: anna_work
"""


import matplotlib.pyplot as plt
import numpy as np
from sklearn.datasets import make_blobs
from sklearn.cluster import KMeans

#%%
sample_data, y = make_blobs(n_samples=150, 
                  n_features=2, 
                  centers=2, 
                  cluster_std=0.5, 
                  shuffle=True, 
                  random_state=0) # keep random_state = 0 so plots always come out the same


#%%
def plot_clustering(k, y_km, close=True):
    plt.scatter(sample_data[:,0], sample_data[:,1],
                s=50,
                c=y_km,
                marker='o',
                #edgecolors=list(y_km+1)
                )
    # plt.grid()
    plt.title("k = "+str(k), fontsize=20)
    #plt.xlabel("Variable 1")
    #plt.ylabel("Variable 2")
    plt.tight_layout()
    
    plt.savefig('plots/vary_k/{}.png'.format(k), dpi=200)
    if close:
        plt.close()


#%%
distortions = []
for k in range(1, 11):
    y_km = KMeans(n_clusters=k, 
                init='k-means++', 
                n_init=10, 
                max_iter=300, 
                random_state=0).fit_predict(sample_data)
    plot_clustering(k, y_km)