"""
1. Read in the animals.csv file. The variables are name,
which gives an abbreviation of the animal name. The other
columns have the following meaning:
    
war	warm-blooded
fly	can fly
ver	vertebrate
end	endangered
gro	live in groups
hai	have hair

A value of 1 indicates "Yes" and a value of 0 indicates "No."

How many animals are in the data set and what are they?
"""
import pandas as pd

#%%
"""
2a. Move the name column to the dataframe index
"""

#%%
"""
2b. Use the .loc method to pull the information about cows (cow)
and lizards (liz)
"""

#%%
"""
2c. Calculate the difference between cow and lizard
(Refer to slide 21 for the distance formula)
"""
from math import sqrt
#%%
"""
3a. Compute the distance matrix between all of the animals
"""
from scipy.spatial.distance import pdist


#%%
"""
3b. Use the squareform function to convert the dist array
you made in the previous step into a square matrix. 
Name the result dist_mat. What are the dimensions of dist_mat?
Based on these dimensions, what does dist_mat tell you?
"""
from scipy.spatial.distance import squareform


"""

"""

#%%
"""
3c. Open dist_mat in the variable explorer. 
Why do 0's appear on the diagonal elements of dist_mat?
What is the lowest value in the matrix other than 0? 
Pick a matrix entry that has this low value, and determine it's
row and column number (remember to start counting from 0)
"""

"""

"""

#%%
"""
3d. Which animals are these?
"""
animals.index[0] # ant
animals.index[1] # bee

#%%
"""
3e. Therefore, what does it mean to have a small distance value between
two animals?
"""

"""
Low distance means the two animals are more similar
"""

#%%
"""
4a. Turn dist_mat into a dataframe, with index and columns both
equal to the animal names. Name this dist_df
"""
dist_df = pd.DataFrame(dist_mat, 
                       columns=animals.index,
                       index=animals.index)

#%%
"""
4b. In step 2c you calculated the distance between cow and lizard.
View the distance_df and confirm the corresponding value is the same.
"""

#%%
"""
4c. Find examples of animals that are similar and examples of 
animals that are different
"""

#%%
"""
5. Use the linkage function to calculate hierarchical clusters
of the animals.
The arguments to linkage should be the dist array, and method="complete"
"""
from scipy.cluster.hierarchy import linkage
row_clusters = linkage(dist, method='complete')


#%%
"""
6. Plot a dendrogram of the clusters.
User labels=animals.index to label the dendrogram with the animal names
"""
import matplotlib.pyplot as plt
from scipy.cluster.hierarchy import dendrogram

dendrogram(row_clusters, labels=animals.index)

plt.title("Animal Hierarchical Clustering")
plt.tight_layout()


#%%
"""
7. Take a moment to understand the plot. How are animals grouped?
Do these groupings make sense?
"""